SystemOrganization addCategory: #Mass!

Object subclass: #MassBackEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassPlan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassServer
	instanceVariableNames: 'mBackEnd teapotInstance mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 17:59'!
deployment

	teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080 }.! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:06'!
development

	teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080. 
			#debugMode -> true }.
	self serveStatic.
	teapotInstance "this is for development ONLY for obvious reasons"
		GET: '/api/<expression>' -> [ :req | 
			Compiler evaluate: (req at: #expression) ].
		"it expects expressions that return compatible values for JSON encoding"! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
forDeployment

	mode := #deployment.

	"teapotInstance := Teapot 
		configure: { 
			#defaultOutput -> #json. 
			#port -> 8080 }.	"! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
forDevelopment

	mode := #development! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 17:12'!
initialize

	mBackEnd := MassBackEnd new.
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:03'!
serveStatic

	teapotInstance 
		serveStatic: '/' 
		from: (SmalltalkImage current imageDirectory parent parent parent asFileReference pathString , '/static').
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 18:01'!
start

	self perform: mode.
	teapotInstance start.
	! !

!MassServer methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/25/2016 17:38'!
stop

	teapotInstance start
	! !

Object subclass: #MassSimulation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!

Object subclass: #MassVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mass'!
